package com.neusoft.smart.pos.strategy.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ShopOtherChargesConfigExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public ShopOtherChargesConfigExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public ShopOtherChargesConfigExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdIsNull() {
            addCriterion("bean_type_id is null");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdIsNotNull() {
            addCriterion("bean_type_id is not null");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdEqualTo(Integer value) {
            addCriterion("bean_type_id =", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdNotEqualTo(Integer value) {
            addCriterion("bean_type_id <>", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdGreaterThan(Integer value) {
            addCriterion("bean_type_id >", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("bean_type_id >=", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdLessThan(Integer value) {
            addCriterion("bean_type_id <", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdLessThanOrEqualTo(Integer value) {
            addCriterion("bean_type_id <=", value, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdIn(List<Integer> values) {
            addCriterion("bean_type_id in", values, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdNotIn(List<Integer> values) {
            addCriterion("bean_type_id not in", values, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdBetween(Integer value1, Integer value2) {
            addCriterion("bean_type_id between", value1, value2, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIdNotBetween(Integer value1, Integer value2) {
            addCriterion("bean_type_id not between", value1, value2, "beanTypeId");
            return (Criteria) this;
        }

        public Criteria andDisplayNameIsNull() {
            addCriterion("display_name is null");
            return (Criteria) this;
        }

        public Criteria andDisplayNameIsNotNull() {
            addCriterion("display_name is not null");
            return (Criteria) this;
        }

        public Criteria andDisplayNameEqualTo(String value) {
            addCriterion("display_name =", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameNotEqualTo(String value) {
            addCriterion("display_name <>", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameGreaterThan(String value) {
            addCriterion("display_name >", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameGreaterThanOrEqualTo(String value) {
            addCriterion("display_name >=", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameLessThan(String value) {
            addCriterion("display_name <", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameLessThanOrEqualTo(String value) {
            addCriterion("display_name <=", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameLike(String value) {
            addCriterion("display_name like", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameNotLike(String value) {
            addCriterion("display_name not like", value, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameIn(List<String> values) {
            addCriterion("display_name in", values, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameNotIn(List<String> values) {
            addCriterion("display_name not in", values, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameBetween(String value1, String value2) {
            addCriterion("display_name between", value1, value2, "displayName");
            return (Criteria) this;
        }

        public Criteria andDisplayNameNotBetween(String value1, String value2) {
            addCriterion("display_name not between", value1, value2, "displayName");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryIsNull() {
            addCriterion("charge_category is null");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryIsNotNull() {
            addCriterion("charge_category is not null");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryEqualTo(String value) {
            addCriterion("charge_category =", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryNotEqualTo(String value) {
            addCriterion("charge_category <>", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryGreaterThan(String value) {
            addCriterion("charge_category >", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryGreaterThanOrEqualTo(String value) {
            addCriterion("charge_category >=", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryLessThan(String value) {
            addCriterion("charge_category <", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryLessThanOrEqualTo(String value) {
            addCriterion("charge_category <=", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryLike(String value) {
            addCriterion("charge_category like", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryNotLike(String value) {
            addCriterion("charge_category not like", value, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryIn(List<String> values) {
            addCriterion("charge_category in", values, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryNotIn(List<String> values) {
            addCriterion("charge_category not in", values, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryBetween(String value1, String value2) {
            addCriterion("charge_category between", value1, value2, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andChargeCategoryNotBetween(String value1, String value2) {
            addCriterion("charge_category not between", value1, value2, "chargeCategory");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNull() {
            addCriterion("description is null");
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNotNull() {
            addCriterion("description is not null");
            return (Criteria) this;
        }

        public Criteria andDescriptionEqualTo(String value) {
            addCriterion("description =", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotEqualTo(String value) {
            addCriterion("description <>", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThan(String value) {
            addCriterion("description >", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("description >=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThan(String value) {
            addCriterion("description <", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLessThanOrEqualTo(String value) {
            addCriterion("description <=", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionLike(String value) {
            addCriterion("description like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotLike(String value) {
            addCriterion("description not like", value, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionIn(List<String> values) {
            addCriterion("description in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotIn(List<String> values) {
            addCriterion("description not in", values, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionBetween(String value1, String value2) {
            addCriterion("description between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andDescriptionNotBetween(String value1, String value2) {
            addCriterion("description not between", value1, value2, "description");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(Integer value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(Integer value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(Integer value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(Integer value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(Integer value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<Integer> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<Integer> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(Integer value1, Integer value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameIsNull() {
            addCriterion("org_entity_table_name is null");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameIsNotNull() {
            addCriterion("org_entity_table_name is not null");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameEqualTo(String value) {
            addCriterion("org_entity_table_name =", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameNotEqualTo(String value) {
            addCriterion("org_entity_table_name <>", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameGreaterThan(String value) {
            addCriterion("org_entity_table_name >", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameGreaterThanOrEqualTo(String value) {
            addCriterion("org_entity_table_name >=", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameLessThan(String value) {
            addCriterion("org_entity_table_name <", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameLessThanOrEqualTo(String value) {
            addCriterion("org_entity_table_name <=", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameLike(String value) {
            addCriterion("org_entity_table_name like", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameNotLike(String value) {
            addCriterion("org_entity_table_name not like", value, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameIn(List<String> values) {
            addCriterion("org_entity_table_name in", values, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameNotIn(List<String> values) {
            addCriterion("org_entity_table_name not in", values, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameBetween(String value1, String value2) {
            addCriterion("org_entity_table_name between", value1, value2, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andOrgEntityTableNameNotBetween(String value1, String value2) {
            addCriterion("org_entity_table_name not between", value1, value2, "orgEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNull() {
            addCriterion("shop_id is null");
            return (Criteria) this;
        }

        public Criteria andShopIdIsNotNull() {
            addCriterion("shop_id is not null");
            return (Criteria) this;
        }

        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("shop_id =", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("shop_id <>", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("shop_id >", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_id >=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("shop_id <", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("shop_id <=", value, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("shop_id in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("shop_id not in", values, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameIsNull() {
            addCriterion("shop_entity_table_name is null");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameIsNotNull() {
            addCriterion("shop_entity_table_name is not null");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameEqualTo(String value) {
            addCriterion("shop_entity_table_name =", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameNotEqualTo(String value) {
            addCriterion("shop_entity_table_name <>", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameGreaterThan(String value) {
            addCriterion("shop_entity_table_name >", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameGreaterThanOrEqualTo(String value) {
            addCriterion("shop_entity_table_name >=", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameLessThan(String value) {
            addCriterion("shop_entity_table_name <", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameLessThanOrEqualTo(String value) {
            addCriterion("shop_entity_table_name <=", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameLike(String value) {
            addCriterion("shop_entity_table_name like", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameNotLike(String value) {
            addCriterion("shop_entity_table_name not like", value, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameIn(List<String> values) {
            addCriterion("shop_entity_table_name in", values, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameNotIn(List<String> values) {
            addCriterion("shop_entity_table_name not in", values, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameBetween(String value1, String value2) {
            addCriterion("shop_entity_table_name between", value1, value2, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andShopEntityTableNameNotBetween(String value1, String value2) {
            addCriterion("shop_entity_table_name not between", value1, value2, "shopEntityTableName");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIsNull() {
            addCriterion("order_type is null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIsNotNull() {
            addCriterion("order_type is not null");
            return (Criteria) this;
        }

        public Criteria andOrderTypeEqualTo(String value) {
            addCriterion("order_type =", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNotEqualTo(String value) {
            addCriterion("order_type <>", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeGreaterThan(String value) {
            addCriterion("order_type >", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeGreaterThanOrEqualTo(String value) {
            addCriterion("order_type >=", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeLessThan(String value) {
            addCriterion("order_type <", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeLessThanOrEqualTo(String value) {
            addCriterion("order_type <=", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeLike(String value) {
            addCriterion("order_type like", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNotLike(String value) {
            addCriterion("order_type not like", value, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeIn(List<String> values) {
            addCriterion("order_type in", values, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNotIn(List<String> values) {
            addCriterion("order_type not in", values, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeBetween(String value1, String value2) {
            addCriterion("order_type between", value1, value2, "orderType");
            return (Criteria) this;
        }

        public Criteria andOrderTypeNotBetween(String value1, String value2) {
            addCriterion("order_type not between", value1, value2, "orderType");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNull() {
            addCriterion("updated_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIsNotNull() {
            addCriterion("updated_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedByEqualTo(String value) {
            addCriterion("updated_by =", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotEqualTo(String value) {
            addCriterion("updated_by <>", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThan(String value) {
            addCriterion("updated_by >", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByGreaterThanOrEqualTo(String value) {
            addCriterion("updated_by >=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThan(String value) {
            addCriterion("updated_by <", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLessThanOrEqualTo(String value) {
            addCriterion("updated_by <=", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByLike(String value) {
            addCriterion("updated_by like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotLike(String value) {
            addCriterion("updated_by not like", value, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByIn(List<String> values) {
            addCriterion("updated_by in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotIn(List<String> values) {
            addCriterion("updated_by not in", values, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByBetween(String value1, String value2) {
            addCriterion("updated_by between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedByNotBetween(String value1, String value2) {
            addCriterion("updated_by not between", value1, value2, "updatedBy");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andBeanParameterIsNull() {
            addCriterion("bean_parameter is null");
            return (Criteria) this;
        }

        public Criteria andBeanParameterIsNotNull() {
            addCriterion("bean_parameter is not null");
            return (Criteria) this;
        }

        public Criteria andBeanParameterEqualTo(String value) {
            addCriterion("bean_parameter =", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterNotEqualTo(String value) {
            addCriterion("bean_parameter <>", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterGreaterThan(String value) {
            addCriterion("bean_parameter >", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterGreaterThanOrEqualTo(String value) {
            addCriterion("bean_parameter >=", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterLessThan(String value) {
            addCriterion("bean_parameter <", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterLessThanOrEqualTo(String value) {
            addCriterion("bean_parameter <=", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterLike(String value) {
            addCriterion("bean_parameter like", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterNotLike(String value) {
            addCriterion("bean_parameter not like", value, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterIn(List<String> values) {
            addCriterion("bean_parameter in", values, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterNotIn(List<String> values) {
            addCriterion("bean_parameter not in", values, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterBetween(String value1, String value2) {
            addCriterion("bean_parameter between", value1, value2, "beanParameter");
            return (Criteria) this;
        }

        public Criteria andBeanParameterNotBetween(String value1, String value2) {
            addCriterion("bean_parameter not between", value1, value2, "beanParameter");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}